using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Net;
using System.Net.Sockets;
using System.Threading;

namespace spring16_2sem_wintcpclient01
{
    public partial class Form1 : Form
    {
        private NetworkStream clientStream;
        private BinaryReader reader;
        private BinaryWriter writer;
        private Thread clientThread;
        private TcpClient client;
        private string message = null;
        //private string serverip;
        IPAddress serverip;
        private Int32 port;

        public Form1()
        {
            InitializeComponent();
            textBox2.Text = "127.0.0.1";
            textBox3.Text = "5000";
        }

        public void RunClient()
        {
            // init tcpClient
            try
            {
                port = Convert.ToInt32(textBox3.Text);
                serverip = IPAddress.Parse(textBox2.Text);
                //1. Create client and connect to server- give
                client = new TcpClient();
                // give IP address and port to talk to
                client.Connect(serverip, port);

                // get network stream
                clientStream = client. GetStream();
                // create read and write objects
                writer = new BinaryWriter(clientStream);
                reader = new BinaryReader(clientStream);
                listBox1.Items.Add("connecting to server");
                // we will ignore cross-thread errors in form load,
                do
                    try
                    {
                        // read message from server until QUIT received
                        message = reader.ReadString();
                        listBox1.Items.Add(message);
                    }
                    catch (Exception error)
                    {
                        MessageBox.Show("Error reading from server "+error.ToString());
                    }
                while (message != "QUIT");
                // close connection
                listBox1.Items.Add("Closing connection");
                writer.Close();
                reader.Close();
                clientStream.Close();
                client.Close();
                Application.Exit(); // and close app and threads
            }
            catch (Exception error)
            {
                MessageBox.Show("Error creating connection " + error.ToString());
            }
        } // end runclient



        private void button1_Click(object sender, EventArgs e)
        {
            //connect
            clientThread = new Thread(new ThreadStart(RunClient));
            clientThread.Start();
            button1.Enabled = false;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //disconnect
            try
            {
                writer.Close();
                reader.Close();
                clientStream.Close();
                client.Close();
                Application.Exit(); // and close app and threads
            } 
            catch (Exception error)
            {
                MessageBox.Show(error.ToString());
            } 
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                // when enter key pressed, write to writer (binaryWriter to ClientStream)
                writer.Write(textBox1.Text);
                // and clear text box
                textBox1.Clear();
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            CheckForIllegalCrossThreadCalls = false;
        }
    }
}